// continually make HTTP requests to a page until the last modified attribute
// changes
module.exports = function (options) {
  "use strict";
  var timeout = options.timeout || 20,
    lastModified = options.lastModified,
    getLastModified = require('./getLastModified'),
    host = options.host,
    path = options.path,
    cancelReq,
    notifyOfFailure = setTimeout(function () {
      if (cancelReq) {
        cancelReq();
      }
      options.err();
    }, timeout * 1000),
    tryRequest = function () {
      if (cancelReq) {
        cancelReq();
      }
      cancelReq = getLastModified(host, path, function (newVal) {
        if (newVal && newVal !== lastModified) {
          clearTimeout(notifyOfFailure);
          options.succ();
        } else {
          setTimeout(tryRequest, 1000);
        }
      });
    };
  tryRequest();
};