// Finds the closest point on a polyline to another point
define([
    "line"
  ],

  function (Line) {
    "use strict";

    var computeDistanceBetween = google.maps.geometry.spherical.computeDistanceBetween;

    var bisectPolyline = function (path, point) {
      var last;
      var closestLine;
      var closestDist = Infinity;
      var dist = 0;
      var result = {
        dist: 0
      };

      path.forEach(function (p) {
        if (last) {
          var line = new Line(last, p);
          var distTo = line.distanceToSquared(point);
          var thisLength = computeDistanceBetween(last, p);
          if (distTo < closestDist) {
            closestLine = line;
            closestDist = distTo;
            var ratio = line.getRatio(point);
            result = {
              dist: dist + thisLength * ratio
            };
          }
          dist += thisLength;
        }
        last = p;
      });

      return result;
    };

    return bisectPolyline;
  }
);