// bicycle layer controls
define([
    'util'
  ],

  function (Util) {

    "use strict";

    var BicyclingLayer = google.maps.BicyclingLayer;
    var select = Util.select;

    return function (gmap, model, $control) {
      var bikeLayer = new BicyclingLayer();

      var updateControls = function () {
        select($control, bikeLayer.getMap());
        model.setBikeLayer(!!bikeLayer.getMap());
      };

      $control.fastClick(function () {
        if (bikeLayer.getMap()) {
          bikeLayer.setMap(null);
        } else {
          bikeLayer.setMap(gmap);
        }
        updateControls();
      });

      if (model.getBikeLayer()) {
        bikeLayer.setMap(gmap);
        updateControls();
      }
    };
  }
);