// add elevation toggle binding
define([
    'jquery',
    'util'
  ],

  function (
    $,
    Util) {

    "use strict";

    var select = Util.select;
    var events = google.maps.event;

    return function (model, map, $element) {
      var $model = $(model);
      // toggle classes from model changes
      var elevationChanged = function () {
        var display = model.getElevation();
        select($element, display);
        $("html").toggleClass("elevation", display);
        events.trigger(map, 'resize');
      };
      // update google map when this element selected
      $element.fastClick(function () {
        model.setElevation(!model.getElevation());
      });
      $model.on('elevation', elevationChanged);
      elevationChanged();
    };
  }
);