// bind controls that center the map at a new location
define([
    'jquery',
    'geocode'
  ],

  function (
    $,
    geocode) {

    "use strict";

    return function (map, $geocode) {
      var removeError = function () {
        $geocode.parent().removeClass("error");
      };
      // fast-focus
      $geocode.on('touchstart', function () { $(this).focus(); });
      $geocode.on('keypress', function (e) {
        var $this = $(this);
        if (e.keyCode === 13 && $this.val()) {
          geocode($this.val(), function (bounds) {
            if (bounds) {
              map.fitBounds(bounds);
              $this.val("");
              $geocode.blur();
              $(document).trigger('geocode');
              removeError();
            }
          }, function () {
            var origVal = $this.val();
            $this.parent().addClass("error");
            // remove error when input changes
            $this.on('keyup', function () {
              if ($this.val() !== origVal) {
                removeError();
                $this.off('keyup');
              }
            });
          });
          return false;
        }
      });
      $(document).on('mousedown', function () {
        $geocode.blur();
      });
    };
  }
);