// make the tiny warning div appear when the route contains warnings or
// copyrights and also udate the about dialog to contain those
// warnings/copyrights
define([
    'jquery'
  ],

  function ($) {

    "use strict";

    var WARNING_TEXT = '.warning-text';
    var GMAP_COPYRIGHT_TEXT = '.gmap-copyright-text';

    return function (model, $warning, DROPDOWN_SPEED) {
      var $model = $(model);
      var $warningText = $(WARNING_TEXT);
      var $gmapCopyright = $(GMAP_COPYRIGHT_TEXT);
      var handleLegalUpdate = function () {
        var value = model.getLegal();
        var warnings = value.warnings;
        var copyrights = value.copyrights;

        $warningText.empty();
        $gmapCopyright.empty();

        if (warnings.length > 0 || copyrights.length > 0) {
          // if have warning/copyright to display, show the warning badge and
          // add text to the about dialog
          $warning.fadeIn(DROPDOWN_SPEED);
          $.each(warnings, function (idx, warning) {
            $("<p>").text(warning).appendTo($warningText);
          });
          $.each(copyrights, function (idx, copyright) {
            $("<p>").text(copyright).appendTo($gmapCopyright);
          });
        } else {
          // otherwise just hide the warning badge
          $warning.fadeOut(DROPDOWN_SPEED);
        }
      };
      $model.on('legal', handleLegalUpdate);
      handleLegalUpdate();
    };
  }
);