// add map type control bindings
define([
    'util'
  ],

  function (Util) {

    "use strict";

    var events = google.maps.event;
    var select = Util.select;

    return function (gmap, $element, googleId) {
      // select this when google map type changes
      var mapTypeChanged = function () {
        select($element, gmap.getMapTypeId() === googleId);
      };
      // update google map when this element selected
      $element.fastClick(function () {
        gmap.setMapTypeId(googleId);
      });
      events.addListener(gmap, 'maptypeid_changed', mapTypeChanged);
      mapTypeChanged();
    };
  }
);