// add route type control bindings
define([
    'jquery',
    'util'
  ],

  function (
    $,
    Util) {

    "use strict";

    var select = Util.select;

    return function (model, $element, googleId) {
      var $model = $(model);
      // select this when google map type changes
      var travelModeChanged = function () {
        select($element, model.getTravelMode() === googleId);
      };
      // update google map when this element selected
      $element.fastClick(function () {
        model.setTravelMode(googleId);
      });
      $model.on('travelMode', travelModeChanged);
      travelModeChanged();
    };
  }
);