// bind controls that populate the show email/embed links
define([
    'jquery',
    'urlshortener',
    'url',
    'rdp',
    'Modernizr'
  ],

  function (
    $,
    URLShortener,
    URL,
    RDP,
    Modernizr) {

    "use strict";

    var block = function () {
      return false;
    };

    return function (map, model, route, $elements) {
      var $show = $elements.SHOW_LINK;
      var $embed = $elements.EMBED;
      var $email = $elements.EMAIL;
      var $label = $elements.TINYURL_LABEL;
      var $shortenSection = $elements.TINYURL;
      var $shorten = $shortenSection.find("input");
      var $both = $embed.add($email);
      var touch = Modernizr.touch;
      var num = 0;
      var orig = "";
      var origLabel = $label.text();
      var token = 0;
      var checkFocus = function () {
        num++;
        if (!touch && num >= 2) {
          $email.focus();
        }
      };

      URLShortener.ready(function () {
        $shortenSection.show();
      });

      var selectAll = function () {
        var $this = $(this);
        this.selectionStart = 0;
        this.selectionEnd = $this.val().length;
        $this.one('mouseup', block);
      };
      $both.focus(selectAll);
      $show.on("show", function () {
        num = 0;
        token++;
        $shorten.attr("checked", false);
        $shorten.attr("disabled", true);
        $label.text(origLabel);
        $embed.val("");
        $email.val("");
        $email.blur();
        // 3rd arg is maxError (not used currently) giving the max error in meters
        URL.build(map, model, route, function (link, iframe) {
          $shorten.attr("disabled", false);
          orig = link;
          $embed.val(iframe);
          $email.val(link);
          checkFocus();
        });
      });
      $show.on("show", checkFocus);
      $show.on('close', RDP.cancel);
      $shorten.on('click', function () {
        var ourToken = ++token;
        if ($shorten.is(":checked")) {
          $label.text(origLabel + "...");
          URLShortener.shorten(orig, function (shorter) {
            if (ourToken === token) {
              $label.text(origLabel);
              // success case
              if ($shorten.is(":checked")) {
                $email.val(shorter);
              }
            }
          }, function () {
            if (ourToken === token) {
              $label.text(origLabel + " error");
              $email.val();
            }
          });
        } else {
          $label.text(origLabel);
          $email.val(orig);
        }
      });
    };
  }
);