// reusable function to setup a "singleclick" event on an MVC object that only fires if no
// doubleclick fires within 1/4 of a second
define([
    'jquery'
  ],

  function ($) {

    "use strict";

    // imports
    var maps = google.maps;
    var events = maps.event;

    var setupSingleClickEvent = function (mvcObject) {
      var doubleClicked=false;

      events.addListener(mvcObject, 'dblclick', function () {
        doubleClicked = true;
      });

      var handleClick = function (e) {
        if (!doubleClicked) {
          events.trigger(mvcObject, 'singleclick', e);
        }
      };

      events.addListener(mvcObject, 'click', function (e) {
        doubleClicked = false;
        setTimeout($.proxy(handleClick, this, e), 250);
      });
    };

    return setupSingleClickEvent;
  }
);