define([
    'jquery',
    'Modernizr'
  ],

  function (
    $,
    Modernizr) {

    "use strict";

    var handheldIdevice = Modernizr.iphone || Modernizr.ipod;
    var webapp = Modernizr.ioswebapp;
    var hideOnFocus;
    var scrollTop = function () {
      window.scrollTo(0, 0);
      hideOnFocus = true;
    };

    var hideAddressBar = function () {
      $("html").height(window.innerHeight + 60);
      scrollTop();
      $("#map_canvas, #outer-wrap, #inner-wrap")
        .height(window.innerHeight);
    };

    var preventShowAddressBarOnInputFocus = function () {
      var focus = false;
      $('input').focus(function () {
        focus = true;
        if (hideOnFocus) {
          scrollTop();
        }
      });
      $('input').blur(function () {
        focus = false;
      });
      $(window).scroll(function () {
        if (!focus) {
          hideOnFocus = false;
        }
      });
    };

    var init = function () {
      // only attempt on iPhones/iPods that aren't in standalone mode
      if (!webapp && handheldIdevice) {
        hideAddressBar();
        preventShowAddressBarOnInputFocus();
        $(window).on('orientationchange mousedown', hideAddressBar);
      }
    };

    return init;
  }
);