define([
    'jquery'
  ],

  function ($) {

    "use strict";
    var slice = Array.prototype.slice;
    var shorten = function (str) {
      return typeof str === "string" ? str.substr(0, 200) : str;
    };
    var LOG = function () {
      var sliced = slice.apply(arguments);
      if (ga) {
        var argsNew = $.map(['send', 'event'].concat(sliced), shorten);
        ga.apply(null, argsNew);
      }
    };
    LOG.error = $.proxy(LOG, null, "error");
    LOG.profile = function (category, variable, label) {
      var startTime = new Date().getTime();
      return function () {
        var timeTaken = new Date().getTime() - startTime;
        if (ga) {
          ga('send', 'timing', category, variable, timeTaken, label);
        }
      };
    };
    LOG.social = function () {
      var sliced = slice.apply(arguments);
      if (ga) {
        var argsNew = $.map(['send', 'social'].concat(sliced), shorten);
        ga.apply(null, argsNew);
      }
    };
    return LOG;
  }
);