// setup print listeners to recenter and resize the map
// currently only works on chrome
define([
    'jquery'
  ],

  function ($) {

    "use strict";

    var setupPrint = function (map) {
      var printTriggered = false;
      var center;

      var beforePrint = function () {
        if (printTriggered){
          return;
        }
        printTriggered = true;
        setTimeout(function() {
          printTriggered=false;
        }, 2000);
        center =  map.getCenter();
        map.setCenter(center);
        google.maps.event.trigger(map, 'resize');
        $(document).trigger('printing');
      };

      var afterPrint = function () {
        map.setCenter(center);
        google.maps.event.trigger(map, 'resize');
      };

      if (window.matchMedia) {
        var mediaQueryList = window.matchMedia('print');
        mediaQueryList.addListener(function (mql) {
          if (mql.matches) {
            beforePrint();
          } else {
            afterPrint();
          }
        });
      }
    };

    return setupPrint;
  }
);