// Ensure at least one QUnit test gets run
// include after qunit, before test files
(function () {
  "use strict";
  var called = false;
  QUnit.testStart(function () {
    called = true;
    window.$ = null;
  });
  QUnit.done(function () {
    if (!called) {
      test("0 tests defined", function () {
        throw new Error("0 tests were defined");
      });
    }
  });
  // namespace for globals
  window.OTGM = window.OTGM || {};
  window.Modernizr = window.Modernizr || {};
  // let me know if I do anything IE won't like
  // window.console = null;
  Array.prototype.filter = function () {
    throw new Error("Don't use filter! not supported in IE");
  };
  window.jQuery(window).on('error', function (e) {
    start();
    test("Failed: global error", function () {
      throw e;
    });
    start();
  });
}());