var iframe = (function () {
  /*global store*/
  "use strict";
  // if custom path to the app is specified, use that instead
  var customPath = location.search.match(/[?&]PATH_TO_APP=(.*?)(?=&|$)/);
  var PATH_TO_APP = customPath ? customPath[1] : "../src/index.html";
  var $iframe = window.jQuery("iframe[name=fixture]");
  var disableGeo = false;
  var doReload = function () {
    $iframe.attr('src', "blank.html");
  };
  var result = {
    frame: frames.fixture,
    test: function (name, toRun) {
      asyncTest(name, function () {
        setTimeout(function () {
          toRun(
            iframe.frame,
            iframe.$$,
            iframe.map,
            iframe.model,
            iframe.controls
          );
          start();
        }, 10);
      });
    },
    asyncTest: function (name, toRun) {
      asyncTest(name, function () {
        setTimeout(function () {
          toRun(
            iframe.frame,
            iframe.$$,
            iframe.map,
            iframe.model,
            iframe.controls
          );
        }, 10);
      });
    },
    reload: function (geo) {
      asyncTest('reloading iframe...', function () {
        expect(0);
        if (geo) {
          disableGeo = true;
        }
        doReload();
      });
    }
  };
  var instrument = function (frameWindow) {
    var google = frameWindow.google;
    var insertBefore = function (object, methodName, pre) {
      var method = object[methodName];
      object[methodName] = function () {
        pre.apply(this, arguments);
        method.apply(this, arguments);
      };
    };
    result.bikeLayers = [];
    insertBefore(google.maps.BicyclingLayer.prototype, 'setMap', function (map) {
      if (map) {
        result.bikeLayers.push(this);
      } else {
        result.bikeLayers.splice(result.bikeLayers.indexOf(this), 0);
      }
    });
    google.maps.Geocoder = function () {
      return {
        geocode: function (input, callback) {
          google.maps.Geocoder.mockImpl(input, callback);
        }
      };
    };

    var frameNav = frameWindow.OTGM;
    frameNav.geolocation = {};
    frameNav.geolocation.getCurrentPosition = function (succ, err) {
      frameNav.geolocation.lastSucc = succ;
      frameNav.geolocation.lastErr = err;
    };
    frameNav.geolocation.watches = [];
    frameNav.geolocation.watchPosition = function () {};
    frameNav.geolocation.clearWatch = function () {};
    if (disableGeo) {
      disableGeo = false;
      frameWindow.OTGM.geolocation = null;
    }
    frameWindow.$ = null;
    frameWindow.jQuery.getScript = function () {
      return {
        fail: function () {}
      };
    };
    frameWindow.fakeModernizr = function (key, value) {
      if (value) {
        frameWindow.jQuery("html").addClass(key).removeClass("no-" + key);
      } else {
        frameWindow.jQuery("html").removeClass(key).addClass("no-" + key);
      }
      frameWindow.Modernizr[key] = value;
    };
    // make it seem like modernizr detected geolocation and not csstransforms3d
    frameWindow.fakeModernizr('geolocation', true);
    frameWindow.fakeModernizr('csstransforms3d', false);
    frameWindow.fakeModernizr('useoffcanvasmenu', false);
  };

  QUnit.config.autostart = false;
  QUnit.config.reorder = false;
  $iframe.load(function () {
    if ($iframe.attr("src") === PATH_TO_APP) {
      // $$ is the jQuery object in the nested iframe
      var $$ = frames.fixture.jQuery;
      $$("iframe[name=feedback]").remove();
      result.$$ = $$;
      instrument(frames.fixture);
      frames.fixture.alert = function () {};
      result.controls = $$("#controls").children().children();

      // listen for gomapready event to start tests
      $$(frames.fixture.document).one('gomapready', function (e, map, model) {
        result.map = map;
        result.model = model;
        start();
      });
      // and in the case where gomap is already loaded, trigger a gomapready event
      $$(frames.fixture.document).trigger('isgomapready');
    } else {
      store.clear();
      $iframe.attr('src', PATH_TO_APP);
    }
  });
  doReload();

  return result;
}());