(function (global) {
  "use strict";
  QUnit.config.autostart = false;

  require.config({
    baseUrl: "../src/js"
  });

  var testModules = [
    "unit/util.test.js",
    "unit/control.test.js",
    "unit/route.test.js",
    "unit/point.test.js",
    "unit/segment.test.js",
    "unit/directions.test.js",
    "unit/map.test.js",
    "unit/model.test.js",
    "unit/url.test.js",
    "unit/rdp.test.js",
    "unit/urlshortener.test.js",
    "unit/geocode.test.js",
    "unit/compressroute.test.js",
    "unit/store.test.js",
    "unit/shake.test.js",
    "unit/fastclick.test.js",
    "unit/sample.test.js",
    "unit/bisectpolyline.test.js",
    "unit/gmapsingleclick.test.js",
    "unit/social.test.js"
  ];

  if (window.d3) {
    testModules.push(
      "unit/elevationprovider.test.js",
      "unit/elevation.test.js",
      "unit/elevationdisplay.test.js"
    );
  }

  require({
      paths: { text: "../components/requirejs-text/text" }
    },

    [
      'point',
      'segment',
      'store',
      'follow',
      'polyfill'
    ],

    function (
      Point,
      Segment,
      Store,
      follow) {

      // export point for mock gmap to use constant
      global.Point = Point;
      global.Segment = Segment;
      global.LOCATION_MARKER = follow.LOCATION_MARKER;
      Store.clear();
      require(testModules, QUnit.start);
    }
  );
}(this));