define([
    "bisectpolyline"
  ],

  function (bisectPolyline) {
    "use strict";

    module("Bisect polyline tests");
    var ll = function (lat, lng) {
      return new google.maps.LatLng(lat, lng);
    };

    test("bisect with no segments", function () {
      strictEqual(bisectPolyline([], ll(0, 0)).dist, 0);
      strictEqual(bisectPolyline([ll(0, 0)], ll(0, 0)).dist, 0);
    });

    test("bisect with 1 segment", function () {
      strictEqual(bisectPolyline([
        ll(0, 0),
        ll(0, 1)
      ], ll(0, 0)).dist, 0, "begin");
      strictEqual(bisectPolyline([
        ll(0, 0),
        ll(0, 1)
      ], ll(0, 1)).dist, 111319.49079327357, "end");
      strictEqual(bisectPolyline([
        ll(0, 0),
        ll(0, 1)
      ], ll(0, 0.5)).dist, 111319.49079327357 / 2, "middle");
      strictEqual(bisectPolyline([
        ll(0, 0),
        ll(0, 1)
      ], ll(10, 0.5)).dist, 111319.49079327357 / 2, "off the middle");
    });

    test("bisect with 2 segments", function () {
      strictEqual(bisectPolyline([
        ll(0, 0),
        ll(0, 1),
        ll(0, 2)
      ], ll(0, 2)).dist, 111319.49079327357 * 2, "end of 2nd");
      strictEqual(bisectPolyline([
        ll(0, 0),
        ll(0, 1),
        ll(0, 2)
      ], ll(1, 1)).dist, 111319.49079327357, "off of intersection");
    });
  }
);