define([
    'jquery',
    'compressroute'
  ],

  function (
    $,
    CompressRoute) {

    "use strict";
    var fixedEncodeURI = function (str) {
      return encodeURI(str).replace(/%5B/g, '[').replace(/%5D/g, ']');
    };
    var fixedEncodeURIComponent = function (str) {
      return encodeURIComponent(str).replace(/[!'()]/g, window.escape).replace(/\*/g, "%2A");
    };
    var all = "";
    for (var i = 63; i < 128; i++) {
      all += String.fromCharCode(i);
    }
    var samples = [
      "",
      google.maps.geometry.encoding.encodePath(new google.maps.LatLng(0, 0)),
      google.maps.geometry.encoding.encodePath(new google.maps.LatLng(0, 0), new google.maps.LatLng(1, 1)),
      all,
      "_nw`Gf{nsLsAyE]oAaAaDYmAc@yBMe@Ia@Qo@gAcDWs@{AmEg@uA]s@aD_Gc@{@e@iA[_AOy@OqBe@eIEsACm@?w@@[@m@ToEHcAFoAD}@?y@?a@CgAGkASoBGy@Iy@YeCaAwGc@oCOeAKu@i@kDSqAQq@I[",
      "a`u`GzoosLE]CI??n@S~@YrA]t@[`@c@n@iAXe@??U_B??tEoBb@MhE{An@UfBi@lAa@~@[vBw@~@[rEcBbE{AnHeC`C{@xMyE|@YdDmAjCcAXKjAg@bBw@vBgA",
      "epx`GrppsL_@FqAPmC\\qDl@_G|@qC^eARuE|@aCb@sARiAXmBx@q@\\m@`@gAx@c@b@u@z@i@t@[f@c@|@eBfDKPU^k@h@YVa@Ta@NYHo@Dc@@e@C{AQ}CYkBYsCYoCc@_AEw@Mg@Ku@UeBm@oBaAu@]yGcD_CgAMGmBu@q@SEAq@Kg@C",
      "arv`GtapsLyBl@YN??V`CTfA`@pABFPn@L`@~@tCJV^hA|@pCt@tB`@lAv@zBbAhCp@bBh@lARf@P`@Xj@R^??Ch@AR?PB^BN@NBpAGdBAhB_@zFC`AOtBMhCG~@Cd@Cb@IhAKv@Oz@Ol@ITKRgAjBoEpH}@|AOZMb@Ox@Gb@Gh@Ep@KvAOtBIrAKhAKhAQjAa@xBk@~CAD",
      "ow~`G`ddrLlCxeAfCxVgAfAcCrD{AlBs@l@wEdCwD|BgDjCuBlBuE~L{D|Gw@hCcAnFSb@_CjCcBrD]lA}@|EWrCQl@kBdDkA~CgCtMaA`EqHlO{H`JqArBc@|AqApMM\\cBjBmAxBm@l@Ia@mBsC_EaHUONg@`BkBgF}QuG_SqPu_@kIuQs@aCs@eDiCaNaAv@CT|BvPVbDOnB{@vFShDMbF@xEj@~BuWvEyCz@gClA_@ZqAfBI_DWcAoAoAcBkD_CqDwBuB{CE_C}Ak@QMsAKsDyCbA_HjBcB_Gq@k@QmBuKE[YMq@HqBgAoIg@uAk@wDOg@gAAWKQK_@q@wCaSMIeEh@aGdAuG~@cBLiC{AmCqAeHsCsGoAo@W}@m@yRgQaBaBoDiEnDyAzBUj@a@xAmBjBrFn@t@f@Pg@Qo@u@uAkEcEgIWmAC_AHkEt@kEVk@XUZE\\DfAv@b@F~@g@b@cAHg@JkBX{B@}@}@cC?{@aCSkAk@k@c@mH}HkAa@a@?iCZOC}AaCi@m@cCoBU{A[g@{AaBK_@Ae@j@oFDmAIgDTkB|Go]TsDPqAd@iA~AkC^qAR_BVsEdA_I^iEL}D[mGCqDW_EAoAdBmGnF_QXiCPwF\\PNjAPTL@TKdA_BNIfAB`C^b@B~ASlBm@dA}@xOwRdC|DzIiFzAs@~BuCtMyLfBkCf@g@vHwFbCkAXa@d@mAb@_CHwAF_HOmBuCeJOwBCgBf@C`@HbFhCh@FVKRO`D}FvBwCv@sAVGZFjAf@fArA`BhBTNpE\\hA|BZVjDQlBLjB?`DUd@SV[hAqCn@aCh@s@b@OjBSjBg@pHeCl@e@lA{BZ[bAe@`AOfCN`BMb@WrCqDN_@xAx@bBb@|APxJb@`ALdAl@pFhGv@b@p@PlDPzEFfH\\~Bd@jC`A~Bf@lBL~DC|Ct@tJpGtA|An@bDAtEN`EfAnIj@xB`P`[r@x@^V~GfCTxBLvEVzAvB~Ez@xChBtEXrBt@nDV`@CrBKrAc@nAiAxBg@tBs@lE?vBh@bEKlB{@~DiBlDgAlC]jCOzCMlKtBtQl@bENnB`Ajl@",
      "_bscGtf_~L|PiAcAib@w_Agx@s[qcAxR}_Bzu@ykA~BswJxMyqAn`C}oAt|Hnk@fdCiMddCmaBld@c{Dj}@iyCxbAszAr|AmiF~UkdB}HepCzuCgoBBsiDjvBywCtTu_AeOqb@tj@sh@~eBeN~jB_aA|Emu@bv@qpCv}@g^fbAikBrj@i\\nJqiAdtAanBfi@yb@bb@wqBxm@yi@haAkxBrkCga@tc@it@_DynAhc@_qA}@wsCdX{z@uZw~@ly@wtHx`Ai|BmCgaEti@{hHjjAknB^oxC`kAc|AzoAgbGjTo|CgbAe}@qKouAl`@iqAxpAif@|b@as@uL{|An^svAOcfD}}@odB}Cy`Bvv@wf@`l@a|AxpByxBoDorCnfBehArUmbDz\\yf@cD}kA`h@}l@vdAysE|m@c^bcAw@rpA}{@|N_{BdpCmoEp^_D_QkgDdT{oAzeA{xAX}cChj@ewA}Xi`Bnn@cuEXwlBr\\_pA`jAqg@ldB}yBpSc_BiK}t@`_@gqBwGaqB``Aam@j|A_hInQeiBeQyy@bbBmiCeF_f@``Aq{CfVasEnuAuyBHagCtiB{kB|{@kgCah@{iHfVahBvg@gs@th@w{BkAqaD|Rt@kn@ecDbGwaC|yAsUnXezAwVueCpXezCpkA}mBdTc~E|u@oaA`lAkaC~dAgjGyWesI~Xg`PlgC{fJxdBa{DzbAq{Av|CgdCze@kbCxjAaw@lSom@qBmbAbm@meCdhEidFyCurFvq@w}BjuAksHcg@o`Dfx@cl@sfD_fDeUslB~p@iqCbG}vBh{AqgBtyBssNxnBibCb~AaoDtEyw@os@cwCnX_{BxCcgBsj@cjG`I{cCwo@g}Aa@i}BmeAigDuQcnBa`Fa}Jms@{dD_|@whG}]wYvJePm_@waAilE}_Ai`OvQaaA|Uk]vtBa}B`dBie@fx@mjCuUamA`{A}_Cjr@w{@jnBetCxjA{aAziBwbAr|Eur@n|ArL|~D",
      "_iv_GvkvkLbsDy__@xkV__QzaWrTxlQtadAweNrre@x|DrsGmtCltZwiYz}k@cmM`s`Buj]lybBe{Yndl@{dL|hjBo`N~n[e{JjacAkbKpsH}tSxxu@~a@tl_@wwUto}@el@lhe@kwq@holB~bAztf@u|Krcr@brFfr_F|pMph{@|yNt}e@q_Cjnz@fuIpfVhmAjvcAjyN`sh@aiBt_kDdcs@dykApld@dikApjeArplDhak@tbsCdrm@nz{A~oDbuz@vzWjjzAew@zddArhRrcc@g[`ag@pnp@hiqBfaKprkHpnc@zlnCsj@jxu@rno@~q|AhcHtrjHl|h@zao@ntVvcpApwj@|rrAvkA|pdDjhLb``AffIm}@poEnxMveWvgObyAxsPt}JpbDrlc@zix@ieFfqyBuOz~a@pwGtvyAheT~ws@pyAbaUoaDvnxAxcJd`cBzxL~cc@e}C~fl@n}Ghr^cQh~y@rmP`oy@buEbei@`In~vAfrGrnMvaPtdDlkGlktAwD|blGjiJ`pvBfdhA~v|AvjShbx@`pAjlfGlyF_JicGj}{@ztDy@b|GryfGjyGdrOjyGxf|F|zQxb]hf@hgp@~{rApscFeLjr_@siKnpMpic@naf@iK|yUt`_@d~o@fvDp`g@vk^zfKd}Cb{\\clNvi_@rqUlzKndDx~OjnSzlPeaHr_rAf}[tcR~~Qtwu@u|Ktdh@jfIlhsA}_Hfk`BmwOjj}AmeSnsQvjA`w~AkjC`fUb~]bxl@~oQ`~nA`|VtxU||a@xvlAtzj@hkh@f~\\tkz@~js@|gNafCrqH|fQ`kg@~aXzjJ_wHfji@f~Qjgn@Glxh@ffh@p}~BtlRvye@pwE|zoA}hJviOsuAhjd@tjPh`RoqKdx}@vnD|}\\izDpiSfy@~o`@|fK{n@bv^tnc@ftItxlAhqXt~YyqTjdTrb\\lgdBolXnt`DkbGdMa~@h_}@_oK|`]kwEx`wCg{EtxTm|H`cAblBn_q@soJ|`y@ofJhmBhqDvkh@"
    ];
    module("CompressRoute compressions of routes");

    $.each(samples, function (idx, input) {
      test("Test compress route " + idx, function () {
        var doubleEncodedOriginal = fixedEncodeURIComponent(fixedEncodeURI(input));
        var compressed = CompressRoute.compress(input);
        var encodedCompressed = fixedEncodeURI(compressed);
        var doubleEncodedCompressed = fixedEncodeURIComponent(encodedCompressed);
        var decodedCompressed = decodeURI(encodedCompressed);
        var decompressed = CompressRoute.decompress(decodedCompressed);

        var sizeComparedToOriginal = doubleEncodedCompressed.length / doubleEncodedOriginal.length;
        var percentOfOrig = Math.round(100 * sizeComparedToOriginal);
        var percentReduced = 100 - percentOfOrig;

        ok(decompressed === input, "compress/decompress must return original");
        ok(doubleEncodedCompressed === compressed, "compressed should not be encodable");
        ok(doubleEncodedCompressed.length <= doubleEncodedOriginal.length, "Compressed " + percentReduced + "% (" + (Math.round(10 / sizeComparedToOriginal) / 10) + "x more data)");
      });
    });

    test("compress/decompress null", function () {
      strictEqual(CompressRoute.decompress(CompressRoute.compress(null)), null);
    });

    test("compress/decompress all invalid", function () {
      var all = "";
      for (var i = 0; i < 50; i++) {
        all += String.fromCharCode(i);
      }
      strictEqual(CompressRoute.decompress(CompressRoute.compress(all)), all);
    });

    test("compress/decompress some valid some invalid", function () {
      var all = "";
      for (var i = 0; i < 256; i++) {
        all += String.fromCharCode(i);
      }
      strictEqual(CompressRoute.decompress(CompressRoute.compress(all)), all);
    });
  }
);