(function (window) {
  "use strict";
  window.OTGM = window.OTGM || {};
  window.OTGM.geolocation = {
    watches: [],
    getCurrentPosition: function (succ, err) {
      this.lastSucc = succ;
      this.lastErr = err;
    },
    watchPosition: function (succ, err) {
      var obj = {
        succ: succ,
        err: err
      };
      this.watches.push(obj);
      return obj;
    },
    update: function (data) {
      window.jQuery.each(this.watches, function (idx, watch) {
        watch.succ(data);
      });
    },
    updateErr: function () {
      window.jQuery.each(this.watches, function (idx, watch) {
        watch.err();
      });
    },
    clearWatch: function (obj) {
      var idx = this.watches.indexOf(obj);
      this.watches.splice(idx, 1);
    }
  };
  window.jQuery("html").addClass("geolocation").removeClass("no-geolocation");
}(this));