/*global $*/
(function (global) {

  "use strict";
  var mixinMapTrack = function (orig, storename) {
    var F = function () {
      var store = storename;
      var that = this;
      var map;
      this.getMap = function () {
        return map;
      };
      this.setMap = function (newMap) {
        var index = map ? map[store].indexOf(that) : -1;
        if (index > -1) {
          map[store].splice(index, 1);
        }
        map = newMap;
        if (newMap) {
          newMap[store].push(that);
        }
      };
      this.setOptions = function (options) {
        that.options = options;
        orig.setOptions.call(orig, options);
      };
      this.setStorename = function (storename) {
        var index = map ? map[store].indexOf(that) : -1;
        if (index > -1) {
          map[store].splice(index, 1);
        }
        store = storename;
        if (map) {
          map[store].push(that);
        }
      };
    };
    F.prototype = orig;
    return new F();
  };
  var MapTrack = function (storename) {
    return mixinMapTrack({}, storename);
  };
  google.maps.ControlPosition = {
    RIGHT_TOP: 0,
    TOP_CENTER: 1,
    TOP_RIGHT: 2,
    TOP_LEFT: 3,
    LEFT_TOP: 4,
    LEFT_BOTTOM: 5
  };
  google.maps.DirectionsService = function () {
    this.route = function (options, callback) {
      // forward invocation to mock implementation
      google.maps.DirectionsService.mockImpl(options, callback);
    };
  };
  google.maps.DirectionsRenderer = function (options) {
    var directions = options.directions;
    this.options = options;
    this.setMap(options.map);
    this.getDirections = function () {
      return directions;
    };
    this.setDirections = function (newdirs) {
      directions = newdirs;
    };
  };
  google.maps.DirectionsRenderer.prototype = new MapTrack("directions");
  var OldMarker = google.maps.Marker;
  var markerMapping = function (options) {
    var result = {};
    result[JSON.stringify(global.Point.SPLITTER_MARKER)] = 'splitters';
    result[JSON.stringify(global.LOCATION_MARKER)] = 'locationDot';
    return result[JSON.stringify(options)] || "markers";
  };
  google.maps.Marker = function (options) {
    var map = options.map;
    options.map = null;
    var result = mixinMapTrack(new OldMarker(options), markerMapping(options));
    result.setMap(map);
    result.dragStart = function (lat, lng) {
      if (arguments.length === 2) {
        result.setPosition(new google.maps.LatLng(lat, lng));
      }
      google.maps.event.trigger(result, 'dragstart');
    };
    result.drag = function (lat, lng) {
      if (arguments.length === 2) {
        result.setPosition(new google.maps.LatLng(lat, lng));
      }
      google.maps.event.trigger(result, 'drag');
    };
    result.dragEnd = function (lat, lng) {
      if (arguments.length === 2) {
        result.setPosition(new google.maps.LatLng(lat, lng));
      }
      google.maps.event.trigger(result, 'dragend');
    };
    result.dragTo = function (lat, lng) {
      result.dragStart(
        result.getPosition().lat(),
        result.getPosition().lng()
      );
      result.dragEnd(lat, lng);
    };
    var oldSetOptions = result.setOptions;
    result.setOptions = function (options) {
      oldSetOptions.apply(result, arguments);
      result.setStorename(markerMapping(options));
    };
    result.options = options;
    return result;
  };
  var OldPolyline = google.maps.Polyline;
  var polylineMapping = function (options) {
    var result = {};
    result[JSON.stringify(global.Segment.TEMP_POLYLINE_STYLE)] = 'tempPolylines';
    result[JSON.stringify(global.Segment.POLYLINE_STYLE)] = 'polylines';
    result[JSON.stringify(global.Segment.ERROR_POLYLINE_STYLE)] = 'errorPolylines';
    result[JSON.stringify(global.Segment.MOUSEOVER_STYLE)] = 'mouseoverPolylines';
    return result[JSON.stringify(options)];
  };
  google.maps.Polyline = function (options) {
    var map = options.map;
    options.map = null;
    var result = mixinMapTrack(new OldPolyline(options), polylineMapping(options));
    var oldSetOptions = result.setOptions;
    result.setOptions = function (newOptions) {
      oldSetOptions.apply(result, arguments);
      result.setStorename(polylineMapping(newOptions));
    };
    result.setMap(map);
    return result;
  };
  var OldCircle = google.maps.Circle;
  google.maps.Circle = function (options) {
    var map = options.map;
    options.map = null;
    var result = mixinMapTrack(new OldCircle(options), "circles");
    result.setMap(map);
    return result;
  };
  google.maps.BicyclingLayer = function () {};
  google.maps.BicyclingLayer.prototype = new MapTrack("bikelayer");
  google.maps.MapTypeId = {
    ROADMAP: 'gmap roadmap',
    TERRAIN: 'gmap terrain',
    HYBRID: 'gmap hybrid'
  };
  google.maps.Geocoder = function () {
    return {
      geocode: function (input, callback) {
        google.maps.Geocoder.mockImpl(input, callback);
      }
    };
  };
  google.maps.Map = function (div, options) {
    var mapTypeId = options.mapTypeId;
    var center = options.center;
    var zoom = options.zoom;
    var splitters = [];
    var mouseoverPolylines = [];
    var markers = [];
    var polylines = [];
    var directions = [];
    var bikelayer = [];
    var tempPolylines = [];
    var errorPolylines = [];
    var locationDot = [];
    var circles = [];
    this.controls = {
      0: [],
      1: [],
      2: [],
      3: [],
      4: [],
      5: []
    };
    this.bounds = new google.maps.LatLngBounds();
    this.getMapTypeId = function () {
      return mapTypeId;
    };
    this.setMapTypeId = function (newtype) {
      mapTypeId = newtype;
      google.maps.event.trigger(this, 'maptypeid_changed');
    };
    this.getBikeLayer = function () {
      return $(this).data('bikeLayer');
    };
    this.getCenter = function () {
      return center;
    };
    this.setCenter = function (newCenter) {
      center = newCenter;
      google.maps.event.trigger(this, 'idle');
      this.bounds = new google.maps.LatLngBounds(
        new google.maps.LatLng(newCenter.lat()-0.1, newCenter.lng()-0.1),
        new google.maps.LatLng(newCenter.lat()+0.1, newCenter.lng()+0.1)
      );
    };
    this.panTo = function (newCenter) {
      center = newCenter;
    };
    this.getZoom = function () {
      return zoom;
    };
    this.setZoom = function (newZoom) {
      zoom = newZoom;
      google.maps.event.trigger(this, 'idle');
    };
    this.getBounds = function () {
      return this.bounds;
    };
    this.fitBounds = function (bounds) {
      this.bounds = bounds;
    };
    this.setBounds = function (bounds) {
      this.bounds = bounds;
    };
    this.click = function (lat, lng) {
      google.maps.event.trigger(this, 'singleclick', {
        latLng: new google.maps.LatLng(lat, lng)
      });
    };
    this.markers = markers;
    this.polylines = polylines;
    this.directions = directions;
    this.bikelayer = bikelayer;
    this.splitters = splitters;
    this.tempPolylines = tempPolylines;
    this.errorPolylines = errorPolylines;
    this.mouseoverPolylines = mouseoverPolylines;
    this.locationDot = locationDot;
    this.circles = circles;
  };
  google.maps.ElevationStatus = {
    OK: "OK",
    ERR: "ERR"
  };
  google.maps.ElevationService = function () {
    return {
      getElevationForLocations: google.maps.ElevationService.getElevationForLocations
    };
  };
  google.maps.ElevationService.getElevationForLocations = sinon.stub();
}(this));