define([
    'point',
    'map'
  ],

  function (
    Point,
    Map) {

    "use strict";
    var LatLng = google.maps.LatLng;
    var map;
    var route = {addPoint: function () {}};

    module("Point tests", {
      setup: function () {
        map = Map.attachTo("#qunit-fixture");
      }
    });

    test("test serialize/deserialize happy path", function () {
      var p = new Point(map, new LatLng(1, 2), route);
      var serialized = p.serialize();
      var p2 = new Point(map, serialized, route);
      var newPos = p2.marker.getPosition();
      deepEqual([newPos.lat(), newPos.lng()], [1, 2],
        "old and new position should match");
    });

    test("test deserialize garbage", function () {
      var p = new Point(map, "garbage", route);
      ok(p);
    });

    // ensure that single click event listener set up
    test("single click is set up", function () {
      var start = new Point(map, new LatLng(1, 2), route);
      expect(1);
      var clock = sinon.useFakeTimers();
      try {
        google.maps.event.addListener(start.marker, 'singleclick', function () {
          ok(true, "slick click called");
        });
        google.maps.event.trigger(start.marker, 'click');
        clock.tick(251);
      } finally {
        clock.restore();
      }
    });
  }
);