define([
    'controls/social',
    'jquery',
    'Modernizr'
  ],

  function (
    setupSocial,
    $,
    Modernizr) {

    "use strict";

    module("social tests", {
      setup: function () {
        sinon.stub($, 'getScript');
        window.ga = sinon.stub();
      },
      teardown: function () {
        Modernizr.ioswebapp = false;
        $.getScript.restore();
      }
    });

    test("happy path", function () {
      setupSocial({});
      strictEqual($.getScript.args[0][0], '//s7.addthis.com/js/300/addthis_widget.js#domready=1');
    });

    test("don't load script when in ios webapp", function () {
      Modernizr.ioswebapp = true;
      setupSocial({});
      ok(!$.getScript.called);
    });

    test("test social event", function () {
      window.addthis = {
        addEventListener: sinon.stub()
      };
      setupSocial({});
      $.getScript.args[0][1]();
      strictEqual(window.addthis.addEventListener.args[0][0], 'addthis.menu.share');
      window.addthis.addEventListener.args[0][1]({
        type: 'addthis.menu.share',
        data: {
          service: 'facebook',
          url: 'http://onthegomap.com'
        }
      });
      deepEqual(window.ga.args, [['send', 'social', 'facebook', 'share', 'http://onthegomap.com']]);
    });
  }
);