define([
    'url',
    'store'
  ],

  function (
    URL,
    Store) {

    "use strict";
    var oldstore;
    module("store tests", {
      setup: function () {
        window.store.clear();
        oldstore = window.store;
      },
      teardown: function () {
        window.store = oldstore;
        Store.setup();
        URL.params.context = null;
        Store.setup();
      }
    });
    test("store access throws exception", function () {
      expect(0);
      window.store = {
        get: function () { throw new Error(); },
        set: function () { throw new Error(); },
        clear: function () { throw new Error(); },
        remove: function () { throw new Error(); }
      };
      Store.setup();
      Store.set("test", "test");
      Store.get("test");
      Store.remove("test");
      Store.clear();
    });

    test("getBoolean", function () {
      Store.set("test", true);
      strictEqual(Store.getBoolean("test"), true);
      Store.set("test", false);
      strictEqual(Store.getBoolean("test"), false);
      Store.set("test", "garbage");
      strictEqual(Store.getBoolean("test"), false);
    });

    test("don't save in share mode unless using force", function () {
      URL.params.context = "share";
      Store.setup();
      Store.set("test", true);
      ok(!Store.getBoolean("test"));

      Store.force.set("test", true);
      strictEqual(Store.force.get("test"), "true");
    });
  }
);